  program
 !the following STDIN and STDOUT code was adapted from code originally written by Frank Piscopo.

  include('winequ.clw')

STD_INPUT_HANDLE    EQUATE(-10)
STD_OUTPUT_HANDLE   EQUATE(-11)

!- For WriteFile() API
OVERLAPPED          GROUP,TYPE
Internal              DWORD
InternalHigh          DWORD
Offset                DWORD
OffsetHigh            DWORD
hEvent                HANDLE
                    END

  map
    MODULE('win32.lib')
      GetStdHandle(DWORD),HANDLE,PASCAL
      ReadFile(HANDLE,LONG,DWORD,Long,Long),BOOL,PASCAL,RAW
      WriteFile(HANDLE,*CSTRING,DWORD,*DWORD,<*OVERLAPPED>),BOOL,PASCAL,RAW
    end
    GetLastName(),String
    PickLastName(),String
  end

r               ulong
!- For sending and receiving IO from server
hStdIn          LONG
hStdOut         LONG


!- Writefile vars
lBytesWritten   ULONG
lBytesRead      DWord
OutCString      CSTRING(255)
InCString      CSTRING(255)
OVERLAPPED_     LIKE(OVERLAPPED)

Names            FILE,DRIVER('Topspeed'),NAME('c:\com4clar\names.tps'),PRE(NAM),BINDABLE        !Declare header file layout
LastNameKey            KEY(NAM:LastName)
Record                RECORD
LastName                String(50)
FirstName               String(50)
                         . .

  code
 if ~command('/COM') then return. !Just in case the exe is accidently run, it doesn't hang around forever.

 bind('NAM:LastName',NAM:LastName)
 bind('getlastname',getlastname)
 bind('picklastname',picklastname)

  hStdIn = GetStdHandle(STD_INPUT_HANDLE)
  hStdOut = GetStdHandle(STD_OUTPUT_HANDLE)

 loop
   r = ReadFile(hStdIn, Address(InCString), 255, Address(lBytesRead), 0)
    if InCstring then
        OutCString = evaluate('clip('&InCString&')') & '<13,10>'
       r = WriteFile(hStdOut,OutCString,LEN(OutCString),lBytesWritten)

    end
 yield
 End

GetLastName Function()
Ret  String(50)
 CODE
 share(Names)
 Set(NAM:LastNameKey)
 Next(Names)
 Ret = NAM:LastName
 Close(Names)
 Return(Ret)


PickLastName Function()
Ret  String(50)
Window WINDOW('Caption'),AT(,,156,96),GRAY
       STRING('This is in a Clarion program'),AT(9,7),USE(?String1)
       STRING('You can type whatever last name you want.'),AT(8,18),USE(?String2)
       PROMPT('Last Name:'),AT(3,35),USE(?Prompt1)
       ENTRY(@s255),AT(46,35,60,10),USE(Ret)
       BUTTON('Close'),AT(110,76,45,14),USE(?CloseButton)
     END

 CODE
 open(Names)
 Set(NAM:LastNameKey)
 Next(Names)
 Ret = NAM:LastName
 Close(Names)
 open(window)
 accept
    case accepted()
    Of ?CloseButton
        break
    End
 end
 Return(Ret)


